//+------------------------------------------------------------------+
//|                                                   TFX_Kayvan.mq4 |
//|                                           Copyright  2008 Wolfe |
//|                                                www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008 Wolfe"
#property link      "www.forex-tsd.com"


extern double  Start_Lot_Size=0.1;//starting lot size for cycle
extern double  Lot_Size_Increment=0.1;//Additional orders will increase by this amount
extern bool    Money_Management=false;//if true mm is used, if false lot size will be start_lot_size
extern double  Risk_Percent=0.5;//percent risk of your AccountFreeMargin() for starting lot size
extern double  Min_Lots = 0.1;//minimum lot size if using money management
extern double  Max_Lots = 5.0;//maximum lot size if using money management  
extern bool    Auto_Restart=true;//set to true if you want EA to re-start after each cycle
extern bool    Double_Lotsize=false;//set to true if you want to just double every lotsize, Lot_Size_Increment ignored if true
extern int     Max_Trades=50;//maximum number of trades allowed
extern bool    Close_All_Max=false;//select true if you want ALL orders to close if Max_Trades is hit 
extern bool    Close_By_Percent=false;//If true it will close by percent, if false it will close by Profit or Loss in $$
extern double  TP_Percent=5;//will take profit if profit is greater than percent of account balance (close all orders)
extern double  SL_Percent=10;//will stop loss if profit is less than percent of account balance (close all orders)
extern double  Close_By_Profit=10;//close if >= to this $ amount
extern double  Close_By_StopLoss=999;//Amount of money to close all if lost
extern bool    Use_Price_Entry=true;
extern bool    Use_Manual_Entry=false;//if selected true you must enter Manuel_Long & Manuel_Short price you want trade to execute
extern double  Manual_Long=0;//Price at which to start cycle long
extern double  Manual_Short=0;//Price at which to start cycle short
extern bool    Start_Long_NOW=false;//if true EA will start long immediately
extern bool    Start_Short_NOW=false;//if true EA will start short immediately
extern int     Slippage=5;//slippage for ordersend command
extern int     Number_Of_Tries=5;//Number of tries to send an OrderSend()command if not going through

double Lot_Size,ClosedProfit,MA_Current,MA_Previous,LastOpen,LastLots,LO,Take_Profit,Stop_Loss,Close_By_Loss,NB,NS,NLD,NSD,First_Open;
int MA_Timeframe,LastTicket,Magic_Number,Last_Open_Time,Current_Bar_Time,Last_Type;
bool Trade_Allowed=true;
int Error=0;
int i=0;
string TFX_LastTicket,TFX_LastOpen,TFX_LastLots,TFX_ClosedProfit,TFX_First_Open,symbol;
int Ticket=0;
bool Restart;
double LotsOptimized,Lot;
//datetime Last_Open_Time,Current_Bar_Time;
#include <TFX_Include_v1_4.mqh>
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {


if (Symbol()=="EURUSDm" || Symbol()=="EURUSD"){TFX_First_Open="TFX_First_Open_EURUSD";TFX_LastTicket="TFX_LastTicket_EURUSD";TFX_LastOpen="TFX_LastOpen_EURUSD";TFX_LastLots="TFX_v1.3_LastLots_EURUSD";TFX_ClosedProfit="TFX_ClosedProfit_EURUSD";Magic_Number=1000;}
if (Symbol()=="USDJPYm" || Symbol()=="USDJPY"){TFX_First_Open="TFX_First_Open_USDJPY";TFX_LastTicket="TFX_LastTicket_USDJPY";TFX_LastOpen="TFX_LastOpen_USDJPY";TFX_LastLots="TFX_v1.3_LastLots_USDJPY";TFX_ClosedProfit="TFX_ClosedProfit_USDJPY";Magic_Number=2001;}
if (Symbol()=="GBPJPYm" || Symbol()=="GBPJPY"){TFX_First_Open="TFX_First_Open_GBPJPY";TFX_LastTicket="TFX_LastTicket_GBPJPY";TFX_LastOpen="TFX_LastOpen_GBPJPY";TFX_LastLots="TFX_v1.3_LastLots_GBPJPY";TFX_ClosedProfit="TFX_ClosedProfit_GBPJPY";Magic_Number=3002;}
if (Symbol()=="USDCHFm" || Symbol()=="USDCHF"){TFX_First_Open="TFX_First_Open_USDCHF";TFX_LastTicket="TFX_LastTicket_USDCHF";TFX_LastOpen="TFX_LastOpen_USDCHF";TFX_LastLots="TFX_v1.3_LastLots_USDCHF";TFX_ClosedProfit="TFX_ClosedProfit_USDCHF";Magic_Number=4003;}
if (Symbol()=="GBPUSDm" || Symbol()=="GBPUSD"){TFX_First_Open="TFX_First_Open_GBPUSD";TFX_LastTicket="TFX_LastTicket_GBPUSD";TFX_LastOpen="TFX_LastOpen_GBPUSD";TFX_LastLots="TFX_v1.3_LastLots_GBPUSD";TFX_ClosedProfit="TFX_ClosedProfit_GBPUSD";Magic_Number=5004;}
if (Symbol()=="EURCHFm" || Symbol()=="EURCHF"){TFX_First_Open="TFX_First_Open_EURCHF";TFX_LastTicket="TFX_LastTicket_EURCHF";TFX_LastOpen="TFX_LastOpen_EURCHF";TFX_LastLots="TFX_v1.3_LastLots_EURCHF";TFX_ClosedProfit="TFX_ClosedProfit_EURCHF";Magic_Number=6005;}
if (Symbol()=="EURGBPm" || Symbol()=="EURGBP"){TFX_First_Open="TFX_First_Open_EURGBP";TFX_LastTicket="TFX_LastTicket_EURGBP";TFX_LastOpen="TFX_LastOpen_EURGBP";TFX_LastLots="TFX_v1.3_LastLots_EURGBP";TFX_ClosedProfit="TFX_ClosedProfit_EURGBP";Magic_Number=7006;}
if (Symbol()=="USDCADm" || Symbol()=="USDCAD"){TFX_First_Open="TFX_First_Open_USDCAD";TFX_LastTicket="TFX_LastTicket_USDCAD";TFX_LastOpen="TFX_LastOpen_USDCAD";TFX_LastLots="TFX_v1.3_LastLots_USDCAD";TFX_ClosedProfit="TFX_ClosedProfit_USDCAD";Magic_Number=8007;}
if (Symbol()=="AUDUSDm" || Symbol()=="AUDUSD"){TFX_First_Open="TFX_First_Open_AUDUSD";TFX_LastTicket="TFX_LastTicket_AUDUSD";TFX_LastOpen="TFX_LastOpen_AUDUSD";TFX_LastLots="TFX_v1.3_LastLots_AUDUSD";TFX_ClosedProfit="TFX_ClosedProfit_AUDUSD";Magic_Number=9008;}
if (Symbol()=="GBPCHFm" || Symbol()=="GBPCHF"){TFX_First_Open="TFX_First_Open_GBPCHF";TFX_LastTicket="TFX_LastTicket_GBPCHF";TFX_LastOpen="TFX_LastOpen_GBPCHF";TFX_LastLots="TFX_v1.3_LastLots_GBPCHF";TFX_ClosedProfit="TFX_ClosedProfit_GBPCHF";Magic_Number=1009;}
if (Symbol()=="CHFJPYm" || Symbol()=="CHFJPY"){TFX_First_Open="TFX_First_Open_CHFJPY";TFX_LastTicket="TFX_LastTicket_CHFJPY";TFX_LastOpen="TFX_LastOpen_CHFJPY";TFX_LastLots="TFX_v1.3_LastLots_CHFJPY";TFX_ClosedProfit="TFX_ClosedProfit_CHFJPY";Magic_Number=1110;}
if (Symbol()=="NZDUSDm" || Symbol()=="NZDUSD"){TFX_First_Open="TFX_First_Open_NZDUSD";TFX_LastTicket="TFX_LastTicket_NZDUSD";TFX_LastOpen="TFX_LastOpen_NZDUSD";TFX_LastLots="TFX_v1.3_LastLots_NZDUSD";TFX_ClosedProfit="TFX_ClosedProfit_NZDUSD";Magic_Number=1211;}
if (Symbol()=="EURCADm" || Symbol()=="EURCAD"){TFX_First_Open="TFX_First_Open_EURCAD";TFX_LastTicket="TFX_LastTicket_EURCAD";TFX_LastOpen="TFX_LastOpen_EURCAD";TFX_LastLots="TFX_v1.3_LastLots_EURCAD";TFX_ClosedProfit="TFX_ClosedProfit_EURCAD";Magic_Number=1312;}
if (Symbol()=="AUDJPYm" || Symbol()=="AUDJPY"){TFX_First_Open="TFX_First_Open_AUDJPY";TFX_LastTicket="TFX_LastTicket_AUDJPY";TFX_LastOpen="TFX_LastOpen_AUDJPY";TFX_LastLots="TFX_v1.3_LastLots_AUDJPY";TFX_ClosedProfit="TFX_ClosedProfit_AUDJPY";Magic_Number=1413;}
if (Symbol()=="EURAUDm" || Symbol()=="EURAUD"){TFX_First_Open="TFX_First_Open_EURAUD";TFX_LastTicket="TFX_LastTicket_EURAUD";TFX_LastOpen="TFX_LastOpen_EURAUD";TFX_LastLots="TFX_v1.3_LastLots_EURAUD";TFX_ClosedProfit="TFX_ClosedProfit_EURAUD";Magic_Number=1514;}
if (Symbol()=="EURJPYm" || Symbol()=="EURJPY"){TFX_First_Open="TFX_First_Open_EURJPY";TFX_LastTicket="TFX_LastTicket_EURJPY";TFX_LastOpen="TFX_LastOpen_EURJPY";TFX_LastLots="TFX_v1.3_LastLots_EURJPY";TFX_ClosedProfit="TFX_ClosedProfit_EURJPY";Magic_Number=1615;}
if (Symbol()=="AUDCADm" || Symbol()=="AUDCAD"){TFX_First_Open="TFX_First_Open_AUDCAD";TFX_LastTicket="TFX_LastTicket_AUDCAD";TFX_LastOpen="TFX_LastOpen_AUDCAD";TFX_LastLots="TFX_v1.3_LastLots_AUDCAD";TFX_ClosedProfit="TFX_ClosedProfit_AUDCAD";Magic_Number=1716;}
if (Symbol()=="AUDNZDm" || Symbol()=="AUDNZD"){TFX_First_Open="TFX_First_Open_AUDNZD";TFX_LastTicket="TFX_LastTicket_AUDNZD";TFX_LastOpen="TFX_LastOpen_AUDNZD";TFX_LastLots="TFX_v1.3_LastLots_AUDNZD";TFX_ClosedProfit="TFX_ClosedProfit_AUDNZD";Magic_Number=1817;}
if (Symbol()=="NZDJPYm" || Symbol()=="NZDJPY"){TFX_First_Open="TFX_First_Open_NZDJPY";TFX_LastTicket="TFX_LastTicket_NZDJPY";TFX_LastOpen="TFX_LastOpen_NZDJPY";TFX_LastLots="TFX_v1.3_LastLots_NZDJPY";TFX_ClosedProfit="TFX_ClosedProfit_NZDJPY";Magic_Number=1918;}

if (Auto_Restart==false){Restart=true;}

if (Use_Manual_Entry==true)
{
if (Manual_Long==0){Trade_Allowed=false;Alert("TRADE DISABLED *** SET MANUEL_LONG");}
if (Manual_Short==0){Trade_Allowed=false;Alert("TRADE DISABLED *** SET MANUEL_SHORT");}
}

Take_Profit=TP_Percent*0.01;
Stop_Loss=SL_Percent*0.01;
Close_By_Loss=Close_By_StopLoss*(-1);



if (OTBM(Magic_Number) == 0 || !GlobalVariableCheck(TFX_LastTicket) || !GlobalVariableCheck(TFX_LastOpen) ||
    !GlobalVariableCheck(TFX_LastLots)) 
 {
  GlobalVariableSet(TFX_LastTicket,0);
  GlobalVariableSet(TFX_LastOpen,0);
  GlobalVariableSet(TFX_LastLots,0);
 }
else 
 { 
  LastTicket = GlobalVariableGet(TFX_LastTicket);
 }
 
if (!GlobalVariableCheck(TFX_ClosedProfit))
 GlobalVariableSet(TFX_ClosedProfit,0);
else ClosedProfit = GlobalVariableGet(TFX_ClosedProfit);
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
if(OrderSelect(LastTicket, SELECT_BY_TICKET)==true)
 {
  Last_Type=OrderType();
  //Print("                                                                                  Last Order Type =  ",Last_Type);
 }
if (Auto_Restart==true){Restart=true;}
 
if ((Use_Manual_Entry==true) && (OTBM(Magic_Number)==0))
{
 Comment("             ");
 Comment("SHORT ENTRY PRICE = ",Manual_Short," LONG ENTRY PRICE = ",Manual_Long);
}
int    spread=MarketInfo(Symbol(),MODE_SPREAD);

/////////////////////////////////////////////////// CHANGE CODE HERE FOR NEXT_BUY OR NEXT_SELL//////////////////////////////////
double Next_Buy=((High[1])+(spread*Point)+(2*Point));                                                                         //
double Next_Sell=((Low[1])-(spread*Point)-(2*Point));                                                                         //
/////////////////////////////////////////////////// CHANGE CODE HERE FOR NEXT_BUY OR NEXT_SELL//////////////////////////////////


//////////////////////////////////////////////////////////////MM//////////////////////////////////////////////////////////////////
if (Money_Management==true)
{
 Start_Lot_Size = NormalizeDouble(MathFloor(AccountFreeMargin()*Risk_Percent/100)/100,1);
   if (Start_Lot_Size > Max_Lots)
     Start_Lot_Size = Max_Lots;
   if (Start_Lot_Size < Min_Lots)
     return(0);
} 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
if (OTBM(Magic_Number) > 0)
{          
if(OrderSelect(LastTicket, SELECT_BY_TICKET)==true)
 {
  LastLots=OrderLots();
  LastOpen=OrderOpenPrice();
 }
GlobalVariableSet(TFX_LastLots,LastLots);
GlobalVariableSet(TFX_LastOpen,LastOpen);
}

if (OTBM(Magic_Number) == 1)
{          
if(OrderSelect(LastTicket, SELECT_BY_TICKET)==true)
 {
  First_Open=OrderOpenPrice();
 }
GlobalVariableSet(TFX_First_Open,First_Open);
First_Open=GlobalVariableGet(TFX_First_Open);
}
//Print("                                                                                           First_Open = ",First_Open);

//////////////////////////////////////////Take Profit or Stop Loss by Percent of Account Balance or by Profit/////////////////////////////////
//                                                    
if ((Use_Price_Entry==true) || (Start_Long_NOW==true) || (Start_Short_NOW==true))
{
if (Close_All_Max==true)
 {
  if (OTBM(Magic_Number)==Max_Trades)
   {
    ClosedProfit = ClosedProfit + OPBM(Magic_Number);
    CBM(Magic_Number);{if (OTBM(Magic_Number)>0){Sleep(1000);CBM(Magic_Number);}}
    Restart=false;
    Print("                                                                             ***MAX TRADE HIT CLOSE ALL PERFORMED***",Symbol());
    if(Auto_Restart==false)
     {
      Alert("Auto_Restart==false ***RESET EA***",Symbol());
     }
   }
 }

if (Close_By_Percent==true)
{ 
if (OPBM(Magic_Number) >= AccountBalance()*(Take_Profit))
 {
  ClosedProfit = ClosedProfit + OPBM(Magic_Number);
  CBM(Magic_Number);{if (OTBM(Magic_Number)>0){Sleep(1000);CBM(Magic_Number);}}
  Restart=false;
  Print("                                                                      ***TAKE PROFIT CLOSE ALL PERFORMED BY PERCENT***",Symbol());
  if(Auto_Restart==false)
     {
      Alert("Auto_Restart==false ***RESET EA***",Symbol());
     }
 }

if (OPBM(Magic_Number) <= AccountBalance()*(-Stop_Loss))
 {
  ClosedProfit = ClosedProfit + OPBM(Magic_Number);
  CBM(Magic_Number);{if (OTBM(Magic_Number)>0){Sleep(1000);CBM(Magic_Number);}}
  Restart=false;
  Print("                                                                        ***STOP LOSS CLOSE ALL PERFORMED BY PERCENT***",Symbol());
  if(Auto_Restart==false)
     {
      Alert("Auto_Restart==false ***RESET EA***",Symbol());
     }
 }
}

if (Close_By_Percent==false)
{
 if (OPBM(Magic_Number) >= Close_By_Profit)
  {
    ClosedProfit = ClosedProfit + OPBM(Magic_Number);
    CBM(Magic_Number);{if (OTBM(Magic_Number)>0){Sleep(1000);CBM(Magic_Number);}}
    Restart=false;
    Print("                                                                     ***TAKE PROFIT CLOSE ALL PERFORMED BY PROFIT***",Symbol());
    if(Auto_Restart==false)
     {
      Alert("Auto_Restart==false ***RESET EA***",Symbol());
     }
  }
  if (OPBM(Magic_Number) <= Close_By_Loss)
  {
    ClosedProfit = ClosedProfit + OPBM(Magic_Number);
    CBM(Magic_Number);{if (OTBM(Magic_Number)>0){Sleep(1000);CBM(Magic_Number);}}
    Restart=false;
    Print("                                                                         ***STOP LOSS CLOSE ALL PERFORMED BY LOSS***",Symbol());
    if(Auto_Restart==false)
     {
      Alert("Auto_Restart==false ***RESET EA***",Symbol());
     }
    }
  }  
}

//////////////////////////////////////////Take Profit or Stop Loss by Percent of Account Balance or by Profit/////////////////////////////////
//                                                     *** If Use_Manuel_Entry = true ***
if (Use_Manual_Entry==true)
{
if (Close_All_Max==true)
 {
  if (OTBM(Magic_Number)==Max_Trades)
   {
    ClosedProfit = ClosedProfit + OPBM(Magic_Number);
    CBM(Magic_Number);{if (OTBM(Magic_Number)>0){Sleep(1000);CBM(Magic_Number);}}
    Print("                                                              ***MAX TRADE HIT CLOSE ALL PERFORMED CYCLE COMPLETE***",Symbol());
    Alert("TRADE CYCLE COMPLETE *** RESET EA *** RESET MANUEL_LONG AND MANUEL SHORT",Symbol());
   }
 }

if (Close_By_Percent==true)
{ 
if (OPBM(Magic_Number) >= AccountBalance()*(Take_Profit))
 {
  ClosedProfit = ClosedProfit + OPBM(Magic_Number);
  CBM(Magic_Number);{if (OTBM(Magic_Number)>0){Sleep(1000);CBM(Magic_Number);}}
  Print("                                                       ***TAKE PROFIT CLOSE ALL PERFORMED BY PERCENT CYCLE COMPLETE***",Symbol());
  Alert("TRADE CYCLE COMPLETE *** RESET EA *** RESET MANUEL_LONG AND MANUEL SHORT",Symbol());
 }

if (OPBM(Magic_Number) <= AccountBalance()*(-Stop_Loss))
 {
  ClosedProfit = ClosedProfit + OPBM(Magic_Number);
  CBM(Magic_Number);{if (OTBM(Magic_Number)>0){Sleep(1000);CBM(Magic_Number);}}
  Print("                                                         ***STOP LOSS CLOSE ALL PERFORMED BY PERCENT CYCLE COMPLETE***",Symbol());
  Alert("TRADE CYCLE COMPLETE *** RESET EA *** RESET MANUEL_LONG AND MANUEL SHORT",Symbol());
 }
}

if (Close_By_Percent==false)
{
 if (OPBM(Magic_Number) >= Close_By_Profit)
  {
    ClosedProfit = ClosedProfit + OPBM(Magic_Number);
    CBM(Magic_Number);{if (OTBM(Magic_Number)>0){Sleep(1000);CBM(Magic_Number);}}
    Print("                                                      ***TAKE PROFIT CLOSE ALL PERFORMED BY PROFIT CYCLE COMPLETE***",Symbol());
    Alert("TRADE CYCLE COMPLETE *** RESET EA *** RESET MANUEL_LONG AND MANUEL SHORT",Symbol());
  }
  if (OPBM(Magic_Number) <= Close_By_Loss)
  {
    ClosedProfit = ClosedProfit + OPBM(Magic_Number);
    CBM(Magic_Number);{if (OTBM(Magic_Number)>0){Sleep(1000);CBM(Magic_Number);}}
    Print("                                                          ***STOP LOSS CLOSE ALL PERFORMED BY LOSS CYCLE COMPLETE***",Symbol());
    Alert("TRADE CYCLE COMPLETE *** RESET EA *** RESET MANUEL_LONG AND MANUEL SHORT",Symbol());
  }
 }  
}

///////////////////////////////////////////Opening of Additional Orders After Initial Order/////////////////////////////////////////////////////////
if ((OTBM(Magic_Number)>0) && (OTBM(Magic_Number)<Max_Trades))
 {
  if ((Ask >= Next_Buy) && (Last_Type==OP_SELL))
   {
    while (!IsTradeAllowed() || IsTradeContextBusy() || !IsConnected() || IsStopped())
     {
      Sleep(1000);
     }
    if (IsTradeAllowed() && !IsTradeContextBusy() && IsConnected() && !IsStopped())
     {
      for(i = 0 ; i < Number_Of_Tries; i++)
       {
        if (Double_Lotsize==false)
         {
          Lot_Size=LastLots+Lot_Size_Increment;
         }
        if (Double_Lotsize==true)
         {
          Lot_Size=LastLots*2;
         }
        RefreshRates();
        Ticket=OrderSend(Symbol(),OP_BUY,Lot_Size,Ask,Slippage,NULL,NULL,"TFX_LONG_ADDITIONAL",Magic_Number,0,Green);
        Error=GetLastError();
        if(Error==0)
         {
          Print("                                                                            NO ERROR***Additional_Long Hit***",Symbol());
          LastTicket = Ticket;
          GlobalVariableSet(TFX_LastTicket,LastTicket);
          break;
         }
        else
         {
          if(Error==4 || Error==136 || Error==137 || Error==146 || Error==128  || Error==138 || Error==148 || Error==134 || Error==6)//Server Errors
           {
            Print("                                                                         !!!!!!!!Ordersend ERROR!!!!!!!!!",Symbol());
            Print("                                                                         Order send error, re-try : ", ErrorDescription(Error),Symbol());
            Sleep(5000);
            continue;
           }
            else //Error
            {
             Print("                                                                         Error opening Additional order : ", ErrorDescription(Error),Symbol());
             break;
            }
          }
        }   
     }
  }
}
if ((OTBM(Magic_Number)>0) && (OTBM(Magic_Number)<Max_Trades))
 {
  if ((Bid <= Next_Sell) && (Last_Type==OP_BUY))
   {
    while (!IsTradeAllowed() || IsTradeContextBusy() || !IsConnected() || IsStopped())
     {
      Sleep(1000);
     }
    if (IsTradeAllowed() && !IsTradeContextBusy() && IsConnected() && !IsStopped())
     {
      for(i = 0 ; i < Number_Of_Tries; i++)
       {
        if (Double_Lotsize==false)
         {
          Lot_Size=LastLots+Lot_Size_Increment;
         }
        if (Double_Lotsize==true)
         {
          Lot_Size=LastLots*2;
         }
        RefreshRates();
        Ticket=OrderSend(Symbol(),OP_SELL,Lot_Size,Bid,Slippage,NULL,NULL,"TFX_SHORT_ADDITIONAL",Magic_Number,0,Red);
        Error=GetLastError();
        if(Error==0)
         {
          Print("                                                                             NO ERROR***Additional_Short Hit***",Symbol());
          LastTicket = Ticket;
          GlobalVariableSet(TFX_LastTicket,LastTicket);
          break;
         }
        else
         {
          if(Error==4 || Error==136 || Error==137 || Error==146 || Error==128  || Error==138 || Error==148 || Error==134 || Error==6)//Server Errors
           {
            Print("                                                                         !!!!!!!!Ordersend ERROR!!!!!!!!!",Symbol());
            Print("                                                                         Order send error, re-try : ", ErrorDescription(Error),Symbol());
            Sleep(5000);
            continue;
            }
             else //Error
              {
               Print("                                                                         Error opening Additional order : ", ErrorDescription(Error),Symbol());
               break;
              }
           }
        }    
     }
  }
} 
//////////////////////////////////////////////////////Open First Order//////////////////////////////////////////////////////////  
if ((OTBM(Magic_Number)==0) && (Use_Price_Entry==true) && (Restart==true))
 {
  if (Ask > High[1])
   {
    while (!IsTradeAllowed() || IsTradeContextBusy() || !IsConnected() || IsStopped())
     {
      Sleep(1000);
     }
    if (IsTradeAllowed() && !IsTradeContextBusy() && IsConnected() && !IsStopped())
     {
      for(i = 0 ; i < Number_Of_Tries; i++)
       {
        Lot_Size=Start_Lot_Size;
        RefreshRates();
        Ticket=OrderSend(Symbol(),OP_BUY,Lot_Size,Ask,Slippage,NULL,NULL,"TFX_LONG_START",Magic_Number,0,Green);
        Error=GetLastError();
        if(Error==0)
         {
          Print("                                                                                  NO ERROR***Start MA_Long Hit***",Symbol());
          LastTicket = Ticket;
          GlobalVariableSet(TFX_LastTicket,LastTicket);
          Restart=false;
          break;
         }
        else
         {
          if(Error==4 || Error==136 || Error==137 || Error==146 || Error==128  || Error==138 || Error==148 || Error==134 || Error==6)//Server Errors
           {
            Print("                                                                            !!!!!!!!Ordersend ERROR!!!!!!!!!",Symbol());
            Print("                                                                            Order send error, re-try : ", ErrorDescription(Error),Symbol());
            Sleep(5000);
            continue;
            }
             else //Error
            {
               Print("                                                                         Error opening First order : ", ErrorDescription(Error),Symbol());
               break;
            }
          }
       }    
    }
  }
  if (Bid < Low[1])
   {
    while (!IsTradeAllowed() || IsTradeContextBusy() || !IsConnected() || IsStopped())
     {
      Sleep(1000);
     }
    if (IsTradeAllowed() && !IsTradeContextBusy() && IsConnected() && !IsStopped())
     {
      for(i = 0 ; i < Number_Of_Tries; i++)
       {
        Lot_Size=Start_Lot_Size;
        RefreshRates();
        Ticket=OrderSend(Symbol(),OP_SELL,Lot_Size,Bid,Slippage,NULL,NULL,"TFX_SHORT_START",Magic_Number,0,Red);
        Error=GetLastError();
        if(Error==0)
         {
          Print("                                                                                 NO ERROR***Start MA_Short Hit***",Symbol());
          LastTicket = Ticket;
          GlobalVariableSet(TFX_LastTicket,LastTicket);
          Restart=false;
          break;
         }
       else
         {
          if(Error==4 || Error==136 || Error==137 || Error==146 || Error==128  || Error==138 || Error==148 || Error==134 || Error==6)//Server Errors
           {
            Print("                                                                            !!!!!!!!Ordersend ERROR!!!!!!!!!",Symbol());
            Print("                                                                            Order send error, re-try : ", ErrorDescription(Error),Symbol());
            Sleep(5000);
            continue;
            }
             else //Error
            {
               Print("                                                                         Error opening First order : ", ErrorDescription(Error),Symbol());
               break;
            }
         }
      }    
    }
  }
}
//////////////////////////////////////////////////Open First Order Manual/////////////////////////////////////////////////////////
if ((OTBM(Magic_Number)==0) && (Use_Manual_Entry==true) && (Trade_Allowed==true))
{
 if (Ask >= Manual_Long)
  {
    while (!IsTradeAllowed() || IsTradeContextBusy() || !IsConnected() || IsStopped())
     {
      Sleep(1000);
     }
    if (IsTradeAllowed() && !IsTradeContextBusy() && IsConnected() && !IsStopped() &&(Ask >= Manual_Long))
     {
      for(i = 0 ; i < Number_Of_Tries; i++)
       {
        Lot_Size=Start_Lot_Size;
        RefreshRates();
        Ticket=OrderSend(Symbol(),OP_BUY,Lot_Size,Ask,Slippage,NULL,NULL,"TFX_LONG_START",Magic_Number,0,Green);
        Error=GetLastError();
        if(Error==0)
         {
          Print("                                                                                  NO ERROR***Start Manuel_Long Hit***",Symbol());
          LastTicket = Ticket;
          GlobalVariableSet(TFX_LastTicket,LastTicket);
          Trade_Allowed=false;
          break;
         }
       else
         {
          if(Error==4 || Error==136 || Error==137 || Error==146 || Error==128  || Error==138 || Error==148 || Error==134 || Error==6)//Server Errors
           {
            Print("                                                                             !!!!!!!!Ordersend ERROR!!!!!!!!!",Symbol());
            Print("                                                                             Order send error, re-try : ", ErrorDescription(Error),Symbol());
            Sleep(5000);
            continue;
            }
             else //Error
            {
               Print("                                                                          Error opening First order : ", ErrorDescription(Error),Symbol());
               break;
            }
          }
       }    
    }
  }
 if (Bid <= Manual_Short)
  {
    while (!IsTradeAllowed() || IsTradeContextBusy() || !IsConnected() || IsStopped())
     {
      Sleep(1000);
     }
    if (IsTradeAllowed() && !IsTradeContextBusy() && IsConnected() && !IsStopped() &&(Bid <= Manual_Short))
     {
      for(i = 0 ; i < Number_Of_Tries; i++)
       {
        Lot_Size=Start_Lot_Size;
        RefreshRates();
        Ticket=OrderSend(Symbol(),OP_SELL,Lot_Size,Bid,Slippage,NULL,NULL,"TFX_SHORT_START",Magic_Number,0,Red);
        Error=GetLastError();
        if(Error==0)
         {
          Print("                                                                                  NO ERROR***Start Manuel_Short Hit***",Symbol());
          LastTicket = Ticket;
          GlobalVariableSet(TFX_LastTicket,LastTicket);
          Trade_Allowed=false;
          break;
         }
       else
         {
          if(Error==4 || Error==136 || Error==137 || Error==146 || Error==128  || Error==138 || Error==148 || Error==134 || Error==6)//Server Errors
           {
            Print("                                                                            !!!!!!!!Ordersend ERROR!!!!!!!!!",Symbol());
            Print("                                                                            Order send error, re-try : ", ErrorDescription(Error),Symbol());
            Sleep(5000);
            continue;
            }
             else //Error
            {
               Print("                                                                         Error opening First order : ", ErrorDescription(Error),Symbol());
               break;
            }
         }
      }    
   }
}
}
/////////////////////////////////////////////////////////////////Start Long NOW///////////////////////////////////////////////////
if ((OTBM(Magic_Number)==0) && ((Start_Long_NOW==true)) && (Restart==true))
 {
  while (!IsTradeAllowed() || IsTradeContextBusy() || !IsConnected() || IsStopped())
     {
      Sleep(1000);
     }
    if (IsTradeAllowed() && !IsTradeContextBusy() && IsConnected() && !IsStopped())
     {
      for(i = 0 ; i < Number_Of_Tries; i++)
       {
        Lot_Size=Start_Lot_Size;
        RefreshRates();
        Ticket=OrderSend(Symbol(),OP_BUY,Lot_Size,Ask,Slippage,NULL,NULL,"TFX_LONG_START",Magic_Number,0,Green);
        Error=GetLastError();
        if(Error==0)
         {
          Print("                                                                                  NO ERROR***Start MA_Long Hit***",Symbol());
          LastTicket = Ticket;
          GlobalVariableSet(TFX_LastTicket,LastTicket);
          Restart=false;
          break;
         }
        else
         {
          if(Error==4 || Error==136 || Error==137 || Error==146 || Error==128  || Error==138 || Error==148 || Error==134 || Error==6)//Server Errors
           {
            Print("                                                                            !!!!!!!!Ordersend ERROR!!!!!!!!!",Symbol());
            Print("                                                                            Order send error, re-try : ", ErrorDescription(Error),Symbol());
            Sleep(5000);
            continue;
            }
             else //Error
            {
               Print("                                                                         Error opening First order : ", ErrorDescription(Error),Symbol());
               break;
            }
          }
       }    
    }
  }
/////////////////////////////////////////////////////////Start Short Now/////////////////////////////////////////////////////////////
if ((OTBM(Magic_Number)==0) && ((Start_Short_NOW==true)) && (Restart==true))
 {
  while (!IsTradeAllowed() || IsTradeContextBusy() || !IsConnected() || IsStopped())
     {
      Sleep(1000);
     }
    if (IsTradeAllowed() && !IsTradeContextBusy() && IsConnected() && !IsStopped())
     {
      for(i = 0 ; i < Number_Of_Tries; i++)
       {
        Lot_Size=Start_Lot_Size;
        RefreshRates();
        Ticket=OrderSend(Symbol(),OP_SELL,Lot_Size,Bid,Slippage,NULL,NULL,"TFX_SHORT_START",Magic_Number,0,Red);
        Error=GetLastError();
        if(Error==0)
         {
          Print("                                                                                 NO ERROR***Start MA_Short Hit***",Symbol());
          LastTicket = Ticket;
          GlobalVariableSet(TFX_LastTicket,LastTicket);
          Restart=false;
          break;
         }
       else
         {
          if(Error==4 || Error==136 || Error==137 || Error==146 || Error==128  || Error==138 || Error==148 || Error==134 || Error==6)//Server Errors
           {
            Print("                                                                            !!!!!!!!Ordersend ERROR!!!!!!!!!",Symbol());
            Print("                                                                            Order send error, re-try : ", ErrorDescription(Error),Symbol());
            Sleep(5000);
            continue;
            }
             else //Error
            {
               Print("                                                                         Error opening First order : ", ErrorDescription(Error),Symbol());
               break;
            }
         }
      }    
    }
  }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

LO=GlobalVariableGet(TFX_LastOpen);
NB=High[1];
NS=Low[1];
NLD=((NB/Point)-(Bid/Point));
NSD=((Bid/Point)-(NS/Point));

Comment("\nOpen Orders = ",OTBM(Magic_Number)," (Max = ",Max_Trades,")",
        "\nOpen Profit = ",(DoubleToStr(OPBM(Magic_Number),2)),
        "\nClosed Profit = ",(DoubleToStr(ClosedProfit,2)),
        "\nLast Open = ",(DoubleToStr(LO,4)),
        "\nCurrent bid ",(DoubleToStr(Bid,4)),
        "\nNext Long + ",NLD," pips"," (",NB,")",
        "\nNext Short - ",NSD," pips"," (",NS,")");

//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+